/*
 * p7array_decl.h -- ParentheTcl (p7tcl)
 *
 # Copyright (c) 2004-2006 Henry Strickland
 #
 # Permission is hereby granted, free of charge, to any person obtaining a
 # copy of this software and associated documentation files (the "Software"),
 # to deal in the Software without restriction, including without limitation
 # the rights to use, copy, modify, merge, publish, distribute, sublicense,
 # and/or sell copies of the Software, and to permit persons to whom the
 # Software is furnished to do so, subject to the following conditions:
 #
 # The above copyright notice and this permission notice shall be included
 # in all copies or substantial portions of the Software.
 #
 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 # THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 # OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 # ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 # OTHER DEALINGS IN THE SOFTWARE.
 #
 #         (* http://www.opensource.org/licenses/mit-license.php *)
 *
 */


typedef struct STRUCT {
#ifdef P7_MAGIC
	int	magic;
#endif
	int	ref_count;
	struct struct_p7cls* cls;
	int	length;
	NAME	data[1];
} *ARRAY;


void FUNC(Link)( ARRAY p ) ;
void FUNC(Unlink)( ARRAY p ) ;

void FUNC(Free)( ARRAY p ) ;


p7err FUNC(Assign)( p7world, ARRAY* rv, ARRAY x) ;

p7err FUNC(New)( p7world, ARRAY* rv, int n) ;

p7err FUNC(Subscript)( p7world, NAME **rv, ARRAY *pRef, int i ) ;

p7err FUNC(GetAt)( p7world, NAME *rv, ARRAY p, int i ) ;

p7err FUNC(PutAt)( p7world, ARRAY p, int i, NAME x ) ;


